<?php
/**
 * Created by PhpStorm.
 * User: pengfei@yidian-inc.com
 * Date: 2021/8/20 2:06 下午
 */

use App\Base\Base;
use App\Services\marketing\ColonelService;
use \Validate\ColonelApplyValidate;
use \Validate\ColonelConfigValidate;
use \App\Services\marketing\PindanActivityColonelConfigService;

class ColonelController extends Base
{

    /**
     * Notes: 申请成为团长
     * User: pengfei@yidian-inc.com
     * Date: 2021/8/20 3:21 下午
     * @throws \App\Exception\custom\MarketingException
     * @throws \App\Exception\custom\ParamException
     */
    public function applyAction()
    {
        $params  = $this->params;
        (new ColonelApplyValidate())->validate();
        $applyId = ColonelService::apply($params);
        return $this->success(['result' => ['applyId' => $applyId]]);
    }

    /**
     * 编辑团长分销配置
     * @throws \App\Exception\custom\MarketingException
     * @throws \App\Exception\custom\ParamException
     */
    public function add_configAction()
    {
        (new ColonelConfigValidate())->validate();

        $params = $this->params;
        PindanActivityColonelConfigService::editColonelConfig($params);
        return $this->success();
    }

    /**
     * 查看团长分销配置
     * @throws \App\Exception\custom\ParamException
     */
    public function colonel_configAction()
    {
        (new ColonelConfigValidate())->scene("date")->validate();

        $params = $this->params;
        $data = PindanActivityColonelConfigService::colonelConfig($params);
        return $this->success(["result"=>$data]);
    }
}