<?php
/**
 * Created by PhpStorm.
 * User: pengfei@yidian-inc.com
 * Date: 2021/8/20 2:23 下午
 */

namespace App\Services\marketing;

use App\Exception\custom\MarketingException;
use App\Models\marketing\mysql\PindanActivityColonelApply;
use Exception;

class ColonelService
{
    /**
     * Notes: 申请成为团长
     * User: pengfei@yidian-inc.com
     * Date: 2021/8/20 4:29 下午
     * @param array $params
     * @return int $applyId
     * @throws MarketingException
     */
    public static function apply(array $params) : int
    {
        $params['phone'] = (string)$params['phone'];
        // TODO 判断用户是否已经成为团长按照 user_id 判断
        if (PindanActivityColonelApply::existPhone($params['phone'])) {
            throw new MarketingException(MarketingException::COLONEL_APPLY_EXIST);
        }
        $colonelData = [
            'phone' => $params['phone'],
            'contact_name' => $params['contact_name'],
            'take_place_name' => $params['take_place_name'],
            'take_place_pic' => $params['take_place_pic'] ?? '',
            'longitude' => $params['longitude'] ?? 0,
            'latitude' => $params['latitude'] ?? 0,
            'location' => $params['location'] ?? '',
            'address'  => $params['address'] ?? '',
            'province' => $params['province'] ?? '',
            'city' => $params['city'] ?? '',
            'area' => $params['area'] ?? '',
        ];
        try {
            if (!$applyId = PindanActivityColonelApply::insertRecord($colonelData)) {
                throw new MarketingException(MarketingException::COLONEL_APPLY_FAILED);
            }
            return $applyId;
        } catch (Exception $e) {
            throw new MarketingException(MarketingException::COLONEL_APPLY_FAILED);
        }
    }
}